#!/usr/bin/env python2.7

"""
CanvasSync by Mathias Perslev

MSc Bioinformatics, University of Copenhagen
February 2017

--------------------------------------------

usage.py, module

Implements the help function that displays the help prompt.

"""

# TODO
# - Needs heavy updating to account for new features

# Future imports
from __future__ import print_function

# Inbuilt modules
import sys


def help():
    print("""
-------------------------
       CanvasSync
  Mathias Perslev, UCPH
      February 2017
-------------------------

Synchronizes files located on a Canvas by Instructure web server to a local folder.
CanvasSync will create a folder hierarchy mirroring the structure of the 'Modules'
section in Canvas. Files will be downloaded into the folder hierarchy.

Usage
-----
CanvasSync [-h] <help> [-s] <reset settings> [-i] <show current settings>

    -h [--help], optional  : Show this help screen

    -s [--setup], optional : Enter settings setup screen
                             Prompt the user for the following three settings:

                             Sync path:             The path to the folder to which syncronization will happen
                             Canvas domain:         The URL to the Canvas domain of the users organization.
                             Authentication token:  The authentication token generated on the Canvas webpage.

                             The first time CanvasSync is launched these settings must be set. Invoking
                             CanvasSync with the -s flag will allow the user to reset these settings.

    -i [--info], optional  : Show currently active settings.

HELP
----
In order to run CanvasSync the following three settings must be specified:

- A path to a folder on the local computer to which synchronization will occur.
  The specified path should include a sub folder name. For instance, to syncronize to a
  folder called 'Canvas' in the Desktop folder, specify "~/Desktop/Canvas"

- The Canvas domain
  For instance, https://absalon.ku.dk

- A Canvas authentication token.
  The token is generated by the user when logged in to the Canvas web server
  and is a signed entity replacing the familiar username-password based authentication. Using the token,
  CanvasSync is able to access resources accessible to the authenticated user. CanvasSync will never
  modify or remove resources on the server.
  The access token is generated in the Canvas web interface. See:
  https://guides.instructure.com/m/4214/l/40399-how-do-i-obtain-an-api-access-token-for-an-account

ADDITIONAL RESOURCES
--------------------
https://canvas.instructure.com/
https://api.instructure.com
""")
    sys.exit(0)
